#include "LRModel.h"
#include "cnpy.h"

double I_stim = 0.0;
std::fstream output_writer;

state_type str2state(const std::string &text, char sep/* =',' */) {
  state_type tokens;
  std::size_t start = 0, end = 0;
  while ((end = text.find(sep, start)) != std::string::npos) {
    tokens.push_back(std::stod(text.substr(start, end - start)));
    start = end + 1;
  }
  tokens.push_back(std::stod(text.substr(start)));
  return tokens;
}

void Cellmodel::write_state(const state_type &x, const double t){

		output_writer <<t <<"\t";
		for(auto const& value: x) {
			output_writer <<"\t" <<value;
		}
		output_writer <<"\n";
}
void Cellmodel::init(std::string &str) {
	state = str2state(str); 
}

Cellmodel* make_model(std::string code) {
	if (code == "wt") {
		return new Model_wt();
	} else if (code == "bs") {
		return new Model_bs();
	} else if (code == "wtm") {
		return new Model_wtm();
	} else if (code == "ttepi") {
		return new Model_ttepi();
	} else {
		throw std::invalid_argument("model: " + code);
	}
}

// Model wt ##################################################

Model_wt::Model_wt() {
	state.push_back(-89.8847524154);
	state.push_back( 0.994944912253);
	state.push_back( 0.000681155448239);
	state.push_back( 0.996450895089);
	state.push_back(-3.95252516673e-323);
	state.push_back( 0.999829826354);
	state.push_back( 0.000109665398447);
	state.push_back( 0.0113367258002);
	state.push_back( 12.5963921328);
	state.push_back( 143.354601536);
	state.push_back( 7.19187334545);
	state.push_back( 1.19729351149);
	state.push_back( 0.00418464131986);
	state.push_back( 0.000887365387884);
	state.push_back( 0.995210665307);
	state.push_back( 0.00418464131722);
	state.push_back(-7.15407055178e-321);
}

Model_wt::Model_wt(state_type &x) {
	std::copy(x.begin(), x.end(), state.begin());
}

unsigned int Model_wt::get_N_states() {
	return 17;
}

void Model_wt::rhs(const state_type &x, state_type &dxdt, double t) {
	dxdt[0] = I_stim - 0.00243810082366898*x[0]*x[4]*x[5]*(0.75*x[8]*exp(0.0374358835078026*x[0]) - 105.0)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[7] + 1111.11111111111*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 0.000697116235508315*x[0]*x[4]*x[5]*(0.75*x[9]*exp(0.0374358835078026*x[0]) - 3.375)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[7] + 1111.11111111111*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 7.80192263574072*x[0]*x[4]*x[5]*(((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[7] + 1111.11111111111*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 0.007016*x[0] - x[12]*x[15]*(0.433 + 0.2598/(6.48182102606265e-7*pow(1.0/((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096), 1.4) + 1))*(x[0] - 26.7123387054983*log(7.0662/(0.01833*x[8] + x[9]))) - 0.05*pow(x[13], 2)*x[14]*(x[0] - 13.3561693527491*log(1.8/((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096))) - 16*x[1]*pow(x[2], 3)*x[3]*(x[0] - 26.7123387054983*log(140/x[8])) - 0.0238624460886417*x[6]*(x[0] - 26.7123387054983*log(4.5/x[9]))/(1.49449105027909*exp(0.0446428571428571*x[0]) + 1.0) - (0.00552*x[0] - 0.14745210965435*log(4.5/x[9]))/(3.49793891302524*exp(-0.167224080267559*x[0]) + 1) - 0.698346260819087*(x[0] - 26.7123387054983*log(4.5/x[9]))/(((0.0302566005849132*pow(1.0/x[9], -2.14553504482562)*exp(0.08032*x[0]) + 9.64976139044134e-18*pow(1.0/x[9], -1.64948691506452)*exp(0.06175*x[0]))/(81717742.8102406*pow(1.0/x[9], 13.7381557962378)*exp(-0.5143*x[0]) + 1) + 1.02/(5.07000951006702e-11*pow(1.0/x[9], -6.37089278126134)*exp(0.2385*x[0]) + 1))*(5.07000951006702e-11*pow(1.0/x[9], -6.37089278126134)*exp(0.2385*x[0]) + 1)) + 0.106849354821993*log(140/x[8]) + 0.0402822067678914*log(1.8/((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)) - (0.383333333333333*x[7] + 0.766666666666667*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.047104)/((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04046) - 0.00025*(-2744000.0L/3.0L*x[7] + 1.8*pow(x[8], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[7] + 1.8*pow(x[8], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1) - 1.6875/((1 + 100/pow(x[8], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[1] = -x[1]*((1.0 - 1.0/(exp((-41.6666666666667)*(x[0] + 40)) + 1))*(3.56*exp(0.079*x[0]) + 310000.0*exp(0.35*x[0])) + 1.0/((0.0497581410839387*exp(-0.0900900900900901*x[0]) + 0.13)*(exp((-41.6666666666667)*(x[0] + 40)) + 1))) + 7.77415426242196e-6*(0.135 - 0.135/(exp((-41.6666666666667)*(x[0] + 40)) + 1))*(-x[1] + 1.0)*exp(-0.147058823529412*x[0]);
	dxdt[2] = -0.08*x[2]*exp(-1.0L/11.0L*x[0]) + (0.32*x[0] + 15.0816)*(-x[2] + 1.0)/(-0.00897780373069724*exp(-0.1*x[0]) + 1);
	dxdt[3] = -x[3]*(0.1212*(1.0 - 1.0/(exp((-41.6666666666667)*(x[0] + 40)) + 1))*exp(-0.01052*x[0])/(0.00396086833990426*exp(-0.1378*x[0]) + 1) + 0.3*exp(-2.535e-7*x[0])/((0.0407622039783662*exp(-0.1*x[0]) + 1)*(exp((-41.6666666666667)*(x[0] + 40)) + 1))) + (1.0 - 1.0/(exp((-41.6666666666667)*(x[0] + 40)) + 1))*(x[0] + 37.78)*(-x[3] + 1.0)*(-3.474e-5*exp(-0.04391*x[0]) - 127140.0*exp(0.2444*x[0]))/(50262745825.954*exp(0.311*x[0]) + 1);
	dxdt[4] = 1.0*(0.035*x[0] + 0.35)*(-x[4] + 1.0/((0.201379497744924*exp(-0.16025641025641*x[0]) + 1.0)*(exp(-41.6666666666667*x[0] - 2500.0) + 1)))*(0.201379497744924*exp(-0.16025641025641*x[0]) + 1.0)/(-0.201379497744924*exp(-0.16025641025641*x[0]) + 1);
	dxdt[5] = (0.02 + 0.0197*exp(-pow(0.0337*x[0] + 0.337, 2.0)))*(-x[5] + 1.0/(exp((1.0L/8.0L)*x[0] + 4) + 1) + 0.6/(exp(-1.0L/20.0L*x[0] + 5.0L/2.0L) + 1));
	dxdt[6] = (-x[6] + 1.0/(0.0568882383461015*exp(-0.133333333333333*x[0]) + 1))*((0.00061*x[0] + 0.023729)/(281.603485023222*exp(0.145*x[0]) - 1) + (0.00138*x[0] + 0.019596)/(-0.174365780410873*exp(-0.123*x[0]) + 1));
	dxdt[7] = -0.00023999003823077*x[0]*x[4]*x[5]*(((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[7] + 1111.11111111111*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 9.27732802666124e-8*x[0] + 4.73529411764706e-5*x[11] - 1.53801857205922e-6*pow(x[13], 2)*x[14]*(x[0] - 13.3561693527491*log(1.8/((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096))) + 0.00705882352941176*x[16] - 0.0811764705882352*(0.00291666666666667*x[7] + 0.00583333333333333*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.0003584)/((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04004) + 1.23909564265093e-6*log(1.8/((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)) - 3.07603714411845e-5*(0.383333333333333*x[7] + 0.766666666666667*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.047104)/((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04046) + 1.53801857205922e-8*(-2744000.0L/3.0L*x[7] + 1.8*pow(x[8], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[7] + 1.8*pow(x[8], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1);
	dxdt[8] = -1.49993773894231e-7*x[0]*x[4]*x[5]*(0.75*x[8]*exp(0.0374358835078026*x[0]) - 105.0)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[7] + 1111.11111111111*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 2.46082971529476e-7*x[0] - 0.000984331886117903*x[1]*pow(x[2], 3)*x[3]*(x[0] - 26.7123387054983*log(140/x[8])) + 6.57345168515085e-6*log(140/x[8]) - 4.61405571617767e-8*(-2744000.0L/3.0L*x[7] + 1.8*pow(x[8], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[7] + 1.8*pow(x[8], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1) - 0.000311448760841993/((1 + 100/pow(x[8], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[9] = 6.1520742882369e-5*I_stim - 4.2887108683832e-8*x[0]*x[4]*x[5]*(0.75*x[9]*exp(0.0374358835078026*x[0]) - 3.375)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[7] + 1111.11111111111*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 6.1520742882369e-5*x[12]*x[15]*(0.433 + 0.2598/(6.48182102606265e-7*pow(1.0/((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096), 1.4) + 1))*(x[0] - 26.7123387054983*log(7.0662/(0.01833*x[8] + x[9]))) - 1.46803541036372e-6*x[6]*(x[0] - 26.7123387054983*log(4.5/x[9]))/(1.49449105027909*exp(0.0446428571428571*x[0]) + 1.0) - 6.1520742882369e-5*(0.00552*x[0] - 0.14745210965435*log(4.5/x[9]))/(3.49793891302524*exp(-0.167224080267559*x[0]) + 1) - 4.29627807547148e-5*(x[0] - 26.7123387054983*log(4.5/x[9]))/(((0.0302566005849132*pow(1.0/x[9], -2.14553504482562)*exp(0.08032*x[0]) + 9.64976139044134e-18*pow(1.0/x[9], -1.64948691506452)*exp(0.06175*x[0]))/(81717742.8102406*pow(1.0/x[9], 13.7381557962378)*exp(-0.5143*x[0]) + 1) + 1.02/(5.07000951006702e-11*pow(1.0/x[9], -6.37089278126134)*exp(0.2385*x[0]) + 1))*(5.07000951006702e-11*pow(1.0/x[9], -6.37089278126134)*exp(0.2385*x[0]) + 1)) + 0.000207632507227995/((1 + 100/pow(x[8], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[10] = -1.0L/240.0L*x[10] + (1.0L/120.0L)*x[11] - x[16] - 1.0L/240.0L*sqrt(3.2*x[10] + pow(-x[10] + 10.8, 2)) + 0.045;
	dxdt[11] = 0.00036231884057971*x[10] - 0.00130797101449275*x[11] + 0.00036231884057971*sqrt(3.2*x[10] + pow(-x[10] + 10.8, 2)) + (0.00291666666666667*x[7] + 0.00583333333333333*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.0003584)/((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04004) - 0.00391304347826087;
	dxdt[12] = (-x[12] + 1.0/(1.09397774310453*exp(-0.0598802395209581*x[0]) + 1))*((7.19e-5*x[0] + 0.002157)/(-0.0117959385197516*exp(-0.148*x[0]) + 1) + (0.000131*x[0] + 0.00393)/(7.85381970442166*exp(0.0687*x[0]) - 1));
	dxdt[13] = (-x[13] + 1.0/(0.27354304157175*exp(-0.0925925925925926*x[0]) + 1))/(3.7 + 6.1/(258.6706305155*exp(0.222222222222222*x[0]) + 1));
	dxdt[14] = (-x[14] + 1.0/(44994.057941343*exp(0.178571428571429*x[0]) + 1))/((1.0 - 1.0/(exp((-41.6666666666667)*x[0]) + 1))*(-0.875*x[0] + 12.0) + 12.0/(exp((-41.6666666666667)*x[0]) + 1));
	dxdt[15] = (-x[15] + 1.0/(1.09397774310453*exp(-0.0598802395209581*x[0]) + 1))*(0.25*(7.19e-5*x[0] + 0.002157)/(-0.0117959385197516*exp(-0.148*x[0]) + 1) + 0.25*(0.000131*x[0] + 0.00393)/(7.85381970442166*exp(0.0687*x[0]) - 1));
	dxdt[16] = (0.210526315789474 + 0.00258947368421053/((1.0L/2.0L)*x[10] + (1.0L/2.0L)*sqrt(3.2*x[10] + pow(-x[10] + 10.8, 2)) - 5.4))*(-4.63239156497105*x[0]*x[4]*x[5]*(((1.0L/3.0L)*x[7] + (2.0L/3.0L)*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((1 + pow((1.0L/2.0L)*x[10] + (1.0L/2.0L)*sqrt(3.2*x[10] + pow(-x[10] + 10.8, 2)) - 5.4, -9))*(exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[7] + 1111.11111111111*sqrt(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[7] + (-9*x[7] + 1.10592)*(-0.00288*x[7] + 0.00019279) - (-2*x[7] + 0.24576)*pow(-x[7] + 0.12288, 2))*pow(0.00864*x[7] + pow(-x[7] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - x[16]);
}

rhs_type Model_wt::get_rhs() {
	return Model_wt::rhs;
}

// Model bs ##################################################

Model_bs::Model_bs() {
	state.push_back(-89.9863526453 ); // Voltage
	state.push_back( 0 ); // d_gate
	state.push_back( 0.9998361223 ); // f_gate
	state.push_back( 0.00010819 ); // X_r
	state.push_back( 0.0113541899 ); // Ca_i
	state.push_back( 12.6287781918 ); // Na_i
	state.push_back( 143.9032192933 ); // K_i
	state.push_back( 7.1976768273 ); // Ca_JSR
	state.push_back( 1.1992257705 ); // Ca_NSR
	state.push_back( 0.0041593655 ); // X_s
	state.push_back( 0.000879064 ); // b_gate
	state.push_back( 0.9952963692 ); // g_gate
	state.push_back( 0.0041593655 ); // X_s2
	state.push_back( 7.9050503334599447068e-323 ); // I_rel
	state.push_back( 0.9999848527 ); // y_gate
	state.push_back( 0.0108622692 ); // z_gate
	state.push_back( 0.2647239905 ); // markov 1-13
	state.push_back( 0.0029986711 );
	state.push_back( 1.26611666411852E-05 );
	state.push_back( 3.10466004246949E-06 );
	state.push_back( 4.35027112113673E-08 );
	state.push_back( 0.7239492459 );
	state.push_back( 0.0082005628 );
	state.push_back( 3.46249012981194E-05 );
	state.push_back( 2.33634992229991E-08 );
	state.push_back( 7.62051838475029E-05 );
	state.push_back( 8.63217135543962E-07 );
	state.push_back( 3.64472645555614E-09 );
	state.push_back( 2.45931569494852E-12 );
}

unsigned int Model_bs::get_N_states() {
	return 29;
}

void Model_bs::rhs(const state_type &x, state_type &dxdt, const double t) {
	dxdt[0] = I_stim - 0.00121905041183449*x[0]*x[1]*x[2]*(0.75*x[5]*exp(0.0374358835078026*x[0]) - 105.0)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 0.000348558117754157*x[0]*x[1]*x[2]*(0.75*x[6]*exp(0.0374358835078026*x[0]) - 3.375)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 3.90096131787036*x[0]*x[1]*x[2]*(((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 0.007016*x[0] - 0.05*pow(x[10], 2)*x[11]*(x[0] - 13.3561693527491*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096))) - x[12]*x[9]*(0.433 + 0.2598/(6.48182102606265e-7*pow(1.0/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096), 1.4) + 1))*(x[0] - 26.7123387054983*log(7.0662/(0.01833*x[5] + x[6]))) - 1.1*x[14]*pow(x[15], 3)*(x[0] - 26.7123387054983*log(4.5/x[6]))*exp(0.01*x[0]) - 0.0238624460886417*x[3]*(x[0] - 26.7123387054983*log(4.5/x[6]))/(1.49449105027909*exp(0.0446428571428571*x[0]) + 1.0) - (0.00552*x[0] - 0.14745210965435*log(4.5/x[6]))/(3.49793891302524*exp(-0.167224080267559*x[0]) + 1) - (x[0] - 26.7123387054983*log(140/x[5]))*(23.5*x[24] + 23.5*x[28]) - 0.698346260819087*(x[0] - 26.7123387054983*log(4.5/x[6]))/(((0.0302566005849132*pow(1.0/x[6], -2.14553504482562)*exp(0.08032*x[0]) + 9.64976139044134e-18*pow(1.0/x[6], -1.64948691506452)*exp(0.06175*x[0]))/(81717742.8102406*pow(1.0/x[6], 13.7381557962378)*exp(-0.5143*x[0]) + 1) + 1.02/(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1))*(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1)) + 0.106849354821993*log(140/x[5]) + 0.0402822067678914*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)) - (0.383333333333333*x[4] + 0.766666666666667*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.047104)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04046) - 0.00025*(-2744000.0L/3.0L*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1) - 1.6875/((1 + 100/pow(x[5], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[1] = 1.0*(0.035*x[0] + 0.35)*(-x[1] + 1.0/((0.201379497744924*exp(-0.16025641025641*x[0]) + 1.0)*(exp(-41.6666666666667*x[0] - 2500.0) + 1)))*(0.201379497744924*exp(-0.16025641025641*x[0]) + 1.0)/(-0.201379497744924*exp(-0.16025641025641*x[0]) + 1);
	dxdt[2] = (0.02 + 0.0197*exp(-pow(0.0337*x[0] + 0.337, 2.0)))*(-x[2] + 1.0/(exp((1.0L/8.0L)*x[0] + 4) + 1) + 0.6/(exp(-1.0L/20.0L*x[0] + 5.0L/2.0L) + 1));
	dxdt[3] = (-x[3] + 1.0/(0.0568882383461015*exp(-0.133333333333333*x[0]) + 1))*((0.00061*x[0] + 0.023729)/(281.603485023222*exp(0.145*x[0]) - 1) + (0.00138*x[0] + 0.019596)/(-0.174365780410873*exp(-0.123*x[0]) + 1));
	dxdt[4] = -0.000119995019115385*x[0]*x[1]*x[2]*(((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 9.27732802666124e-8*x[0] - 1.53801857205922e-6*pow(x[10], 2)*x[11]*(x[0] - 13.3561693527491*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096))) + 0.00705882352941176*x[13] + 4.73529411764706e-5*x[8] - 0.0811764705882352*(0.00291666666666667*x[4] + 0.00583333333333333*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.0003584)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04004) + 1.23909564265093e-6*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)) - 3.07603714411845e-5*(0.383333333333333*x[4] + 0.766666666666667*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.047104)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04046) + 1.53801857205922e-8*(-2744000.0L/3.0L*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1);
	dxdt[5] = -7.49968869471155e-8*x[0]*x[1]*x[2]*(0.75*x[5]*exp(0.0374358835078026*x[0]) - 105.0)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 2.46082971529476e-7*x[0] - 6.1520742882369e-5*(x[0] - 26.7123387054983*log(140/x[5]))*(23.5*x[24] + 23.5*x[28]) + 6.57345168515085e-6*log(140/x[5]) - 4.61405571617767e-8*(-2744000.0L/3.0L*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1) - 0.000311448760841993/((1 + 100/pow(x[5], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[6] = 6.1520742882369e-5*I_stim - 2.1443554341916e-8*x[0]*x[1]*x[2]*(0.75*x[6]*exp(0.0374358835078026*x[0]) - 3.375)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 6.1520742882369e-5*x[12]*x[9]*(0.433 + 0.2598/(6.48182102606265e-7*pow(1.0/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096), 1.4) + 1))*(x[0] - 26.7123387054983*log(7.0662/(0.01833*x[5] + x[6]))) - 6.76728171706059e-5*x[14]*pow(x[15], 3)*(x[0] - 26.7123387054983*log(4.5/x[6]))*exp(0.01*x[0]) - 1.46803541036372e-6*x[3]*(x[0] - 26.7123387054983*log(4.5/x[6]))/(1.49449105027909*exp(0.0446428571428571*x[0]) + 1.0) - 6.1520742882369e-5*(0.00552*x[0] - 0.14745210965435*log(4.5/x[6]))/(3.49793891302524*exp(-0.167224080267559*x[0]) + 1) - 4.29627807547148e-5*(x[0] - 26.7123387054983*log(4.5/x[6]))/(((0.0302566005849132*pow(1.0/x[6], -2.14553504482562)*exp(0.08032*x[0]) + 9.64976139044134e-18*pow(1.0/x[6], -1.64948691506452)*exp(0.06175*x[0]))/(81717742.8102406*pow(1.0/x[6], 13.7381557962378)*exp(-0.5143*x[0]) + 1) + 1.02/(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1))*(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1)) + 0.000207632507227995/((1 + 100/pow(x[5], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[7] = -x[13] - 1.0L/240.0L*x[7] + (1.0L/120.0L)*x[8] - 1.0L/240.0L*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) + 0.045;
	dxdt[8] = 0.00036231884057971*x[7] - 0.00130797101449275*x[8] + 0.00036231884057971*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) + (0.00291666666666667*x[4] + 0.00583333333333333*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.0003584)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04004) - 0.00391304347826087;
	dxdt[9] = (-x[9] + 1.0/(1.09397774310453*exp(-0.0598802395209581*x[0]) + 1))*((7.19e-5*x[0] + 0.002157)/(-0.0117959385197516*exp(-0.148*x[0]) + 1) + (0.000131*x[0] + 0.00393)/(7.85381970442166*exp(0.0687*x[0]) - 1));
	dxdt[10] = (-x[10] + 1.0/(0.27354304157175*exp(-0.0925925925925926*x[0]) + 1))/(3.7 + 6.1/(258.6706305155*exp(0.222222222222222*x[0]) + 1));
	dxdt[11] = (-x[11] + 1.0/(44994.057941343*exp(0.178571428571429*x[0]) + 1))/((1.0 - 1.0/(exp((-41.6666666666667)*x[0]) + 1))*(-0.875*x[0] + 12.0) + 12.0/(exp((-41.6666666666667)*x[0]) + 1));
	dxdt[12] = (-x[12] + 1.0/(1.09397774310453*exp(-0.0598802395209581*x[0]) + 1))*(0.25*(7.19e-5*x[0] + 0.002157)/(-0.0117959385197516*exp(-0.148*x[0]) + 1) + 0.25*(0.000131*x[0] + 0.00393)/(7.85381970442166*exp(0.0687*x[0]) - 1));
	dxdt[13] = (0.210526315789474 + 0.00258947368421053/((1.0L/2.0L)*x[7] + (1.0L/2.0L)*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) - 5.4))*(-2.31619578248553*x[0]*x[1]*x[2]*(((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((1 + pow((1.0L/2.0L)*x[7] + (1.0L/2.0L)*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) - 5.4, -9))*(exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - x[13]);
	dxdt[14] = -14.8413159102577*x[14]*exp(0.2*x[0])/(148.413159102577*exp(0.2*x[0]) + 1.0) + 0.015*(-x[14] + 1.0)/(162754.791419004*exp(0.2*x[0]) + 1.0);
	dxdt[15] = -0.273237224472926*x[15]*exp(-0.04*x[0])/(0.0273237224472926*exp(-0.04*x[0]) + 1.0) + 2.01896517994655*(-x[15] + 1.0)*exp(0.04*x[0])/(0.201896517994655*exp(0.04*x[0]) + 1.0);
	dxdt[16] = x[16]*(-1.51732e-7*exp(-0.12987012987013*x[0]) - 3.802/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0]))) + 0.1917*x[17]*exp(-0.0492610837438424*x[0]) + x[21]*(2.0e-5*x[0] + 0.0084);
	dxdt[17] = 3.802*x[16]/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0])) + x[17]*(-1.51732e-7*exp(-0.12987012987013*x[0]) - 0.1917*exp(-0.0492610837438424*x[0]) - 3.802/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0]))) + 0.255858046613164*x[18]*exp(-0.0492610837438424*x[0]) + x[22]*(2.0e-5*x[0] + 0.0084);
	dxdt[18] = 3.802*x[17]/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0])) + x[18]*(-1.51732e-7*exp(-0.12987012987013*x[0]) - 0.255858046613164*exp(-0.0492610837438424*x[0]) - 0.09178*exp(0.0336927223719677*x[0]) - 1.47053883789031e-5*exp(-0.0469163237543198*x[0])/((2.0e-5*x[0] + 0.0084)*(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0])))) + 1.51732e-7*x[19]*exp(-0.12987012987013*x[0]) + x[23]*(2.0e-5*x[0] + 0.0084) + 9.178*x[24]*exp(0.0336927223719677*x[0]);
	dxdt[19] = 0.09178*x[18]*exp(0.0336927223719677*x[0]) + x[19]*(-1.51732e-7*exp(-0.12987012987013*x[0]) - 0.000262228571428571*exp(0.0336927223719677*x[0])) + 7.5866e-9*x[20]*exp(-0.12987012987013*x[0]);
	dxdt[20] = 0.000262228571428571*x[19]*exp(0.0336927223719677*x[0]) - 7.5866e-9*x[20]*exp(-0.12987012987013*x[0]);
	dxdt[21] = 1.51732e-7*x[16]*exp(-0.12987012987013*x[0]) + x[21]*(-2.0e-5*x[0] - 0.0084001 - 3.802/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0]))) + 0.1917*x[22]*exp(-0.0492610837438424*x[0]) + 0.00095*x[25];
	dxdt[22] = 1.51732e-7*x[17]*exp(-0.12987012987013*x[0]) + 3.802*x[21]/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0])) + x[22]*(-2.0e-5*x[0] - 0.1917*exp(-0.0492610837438424*x[0]) - 0.0084001 - 3.802/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0]))) + 0.255858046613164*x[23]*exp(-0.0492610837438424*x[0]) + 0.00095*x[26];
	dxdt[23] = 1.51732e-7*x[18]*exp(-0.12987012987013*x[0]) + 3.802*x[22]/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0])) + x[23]*(-2.0e-5*x[0] - 0.255858046613164*exp(-0.0492610837438424*x[0]) - 0.0084001 - 3.802/(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0]))) + 0.360048370091871*x[24]*exp(-0.0492610837438424*x[0]) + 0.00095*x[27];
	dxdt[24] = 1.47053883789031e-5*x[18]*exp(-0.0469163237543198*x[0])/((2.0e-5*x[0] + 0.0084)*(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0]))) + 3.802*x[23]/(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0])) + x[24]*(-0.360048370091871*exp(-0.0492610837438424*x[0]) - 9.178*exp(0.0336927223719677*x[0]) - 1.0e-7) + 0.00095*x[28];
	dxdt[25] = 1.0e-7*x[21] + x[25]*(-0.00095 - 3.802/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0]))) + 0.1917*x[26]*exp(-0.0492610837438424*x[0]);
	dxdt[26] = 1.0e-7*x[22] + 3.802*x[25]/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0])) + x[26]*(-0.1917*exp(-0.0492610837438424*x[0]) - 0.00095 - 3.802/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0]))) + 0.255858046613164*x[27]*exp(-0.0492610837438424*x[0]);
	dxdt[27] = 1.0e-7*x[23] + 3.802*x[26]/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0])) + x[27]*(-0.255858046613164*exp(-0.0492610837438424*x[0]) - 0.00095 - 3.802/(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0]))) + 0.360048370091871*x[28]*exp(-0.0492610837438424*x[0]);
	dxdt[28] = 1.0e-7*x[24] + 3.802*x[27]/(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0])) + x[28]*(-0.360048370091871*exp(-0.0492610837438424*x[0]) - 0.00095);
}

rhs_type Model_bs::get_rhs() {
	return Model_bs::rhs;
}

// model wtm ############################################################

Model_wtm::Model_wtm() {
	state.push_back(-89.9863526453 ); // Voltage
	state.push_back( 0 ); // d_gate
	state.push_back( 0.9998361223 ); // f_gate
	state.push_back( 0.00010819 ); // X_r
	state.push_back( 0.0113541899 ); // Ca_i
	state.push_back( 12.6287781918 ); // Na_i
	state.push_back( 143.9032192933 ); // K_i
	state.push_back( 7.1976768273 ); // Ca_JSR
	state.push_back( 1.1992257705 ); // Ca_NSR
	state.push_back( 0.0041593655 ); // X_s
	state.push_back( 0.000879064 ); // b_gate
	state.push_back( 0.9952963692 ); // g_gate
	state.push_back( 0.0041593655 ); // X_s2
	state.push_back( 7.9050503334599447068e-323 ); // I_rel
	state.push_back( 0.9999848527 ); // y_gate
	state.push_back( 0.0108622692 ); // z_gate
	state.push_back( 1.0/9 ); // markov 1-9
	state.push_back( 1.0/9 );
	state.push_back( 1.0/9 );
	state.push_back( 1.0/9 );
	state.push_back( 1.0/9 );
	state.push_back( 1.0/9 );
	state.push_back( 1.0/9 );
	state.push_back( 1.0/9 );
	state.push_back( 1.0/9 );
}

unsigned int Model_wtm::get_N_states() {
	return 25;
}

void Model_wtm::rhs(const state_type &x, state_type &dxdt, const double t) {
	dxdt[0] = I_stim - 0.00121905041183449*x[0]*x[1]*x[2]*(0.75*x[5]*exp(0.0374358835078026*x[0]) - 105.0)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 0.000348558117754157*x[0]*x[1]*x[2]*(0.75*x[6]*exp(0.0374358835078026*x[0]) - 3.375)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 3.90096131787036*x[0]*x[1]*x[2]*(((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 0.007016*x[0] - 0.05*pow(x[10], 2)*x[11]*(x[0] - 13.3561693527491*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096))) - x[12]*x[9]*(0.433 + 0.2598/(6.48182102606265e-7*pow(1.0/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096), 1.4) + 1))*(x[0] - 26.7123387054983*log(7.0662/(0.01833*x[5] + x[6]))) - 1.1*x[14]*pow(x[15], 3)*(x[0] - 26.7123387054983*log(4.5/x[6]))*exp(0.01*x[0]) - 23.5*x[24]*(x[0] - 26.7123387054983*log(140/x[5])) - 0.0238624460886417*x[3]*(x[0] - 26.7123387054983*log(4.5/x[6]))/(1.49449105027909*exp(0.0446428571428571*x[0]) + 1.0) - (0.00552*x[0] - 0.14745210965435*log(4.5/x[6]))/(3.49793891302524*exp(-0.167224080267559*x[0]) + 1) - 0.698346260819087*(x[0] - 26.7123387054983*log(4.5/x[6]))/(((0.0302566005849132*pow(1.0/x[6], -2.14553504482562)*exp(0.08032*x[0]) + 9.64976139044134e-18*pow(1.0/x[6], -1.64948691506452)*exp(0.06175*x[0]))/(81717742.8102406*pow(1.0/x[6], 13.7381557962378)*exp(-0.5143*x[0]) + 1) + 1.02/(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1))*(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1)) + 0.106849354821993*log(140/x[5]) + 0.0402822067678914*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)) - (0.383333333333333*x[4] + 0.766666666666667*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.047104)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04046) - 0.00025*(-2744000.0L/3.0L*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1) - 1.6875/((1 + 100/pow(x[5], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[1] = 1.0*(0.035*x[0] + 0.35)*(-x[1] + 1.0/((0.201379497744924*exp(-0.16025641025641*x[0]) + 1.0)*(exp(-41.6666666666667*x[0] - 2500.0) + 1)))*(0.201379497744924*exp(-0.16025641025641*x[0]) + 1.0)/(-0.201379497744924*exp(-0.16025641025641*x[0]) + 1);
	dxdt[2] = (0.02 + 0.0197*exp(-pow(0.0337*x[0] + 0.337, 2.0)))*(-x[2] + 1.0/(exp((1.0L/8.0L)*x[0] + 4) + 1) + 0.6/(exp(-1.0L/20.0L*x[0] + 5.0L/2.0L) + 1));
	dxdt[3] = (-x[3] + 1.0/(0.0568882383461015*exp(-0.133333333333333*x[0]) + 1))*((0.00061*x[0] + 0.023729)/(281.603485023222*exp(0.145*x[0]) - 1) + (0.00138*x[0] + 0.019596)/(-0.174365780410873*exp(-0.123*x[0]) + 1));
	dxdt[4] = -0.000119995019115385*x[0]*x[1]*x[2]*(((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 9.27732802666124e-8*x[0] - 1.53801857205922e-6*pow(x[10], 2)*x[11]*(x[0] - 13.3561693527491*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096))) + 0.00705882352941176*x[13] + 4.73529411764706e-5*x[8] - 0.0811764705882352*(0.00291666666666667*x[4] + 0.00583333333333333*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.0003584)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04004) + 1.23909564265093e-6*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)) - 3.07603714411845e-5*(0.383333333333333*x[4] + 0.766666666666667*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.047104)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04046) + 1.53801857205922e-8*(-2744000.0L/3.0L*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1);
	dxdt[5] = -7.49968869471155e-8*x[0]*x[1]*x[2]*(0.75*x[5]*exp(0.0374358835078026*x[0]) - 105.0)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 2.46082971529476e-7*x[0] - 0.00144573745773567*x[24]*(x[0] - 26.7123387054983*log(140/x[5])) + 6.57345168515085e-6*log(140/x[5]) - 4.61405571617767e-8*(-2744000.0L/3.0L*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1) - 0.000311448760841993/((1 + 100/pow(x[5], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[6] = 6.1520742882369e-5*I_stim - 2.1443554341916e-8*x[0]*x[1]*x[2]*(0.75*x[6]*exp(0.0374358835078026*x[0]) - 3.375)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 6.1520742882369e-5*x[12]*x[9]*(0.433 + 0.2598/(6.48182102606265e-7*pow(1.0/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096), 1.4) + 1))*(x[0] - 26.7123387054983*log(7.0662/(0.01833*x[5] + x[6]))) - 6.76728171706059e-5*x[14]*pow(x[15], 3)*(x[0] - 26.7123387054983*log(4.5/x[6]))*exp(0.01*x[0]) - 1.46803541036372e-6*x[3]*(x[0] - 26.7123387054983*log(4.5/x[6]))/(1.49449105027909*exp(0.0446428571428571*x[0]) + 1.0) - 6.1520742882369e-5*(0.00552*x[0] - 0.14745210965435*log(4.5/x[6]))/(3.49793891302524*exp(-0.167224080267559*x[0]) + 1) - 4.29627807547148e-5*(x[0] - 26.7123387054983*log(4.5/x[6]))/(((0.0302566005849132*pow(1.0/x[6], -2.14553504482562)*exp(0.08032*x[0]) + 9.64976139044134e-18*pow(1.0/x[6], -1.64948691506452)*exp(0.06175*x[0]))/(81717742.8102406*pow(1.0/x[6], 13.7381557962378)*exp(-0.5143*x[0]) + 1) + 1.02/(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1))*(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1)) + 0.000207632507227995/((1 + 100/pow(x[5], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[7] = -x[13] - 1.0L/240.0L*x[7] + (1.0L/120.0L)*x[8] - 1.0L/240.0L*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) + 0.045;
	dxdt[8] = 0.00036231884057971*x[7] - 0.00130797101449275*x[8] + 0.00036231884057971*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) + (0.00291666666666667*x[4] + 0.00583333333333333*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.0003584)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04004) - 0.00391304347826087;
	dxdt[9] = (-x[9] + 1.0/(1.09397774310453*exp(-0.0598802395209581*x[0]) + 1))*((7.19e-5*x[0] + 0.002157)/(-0.0117959385197516*exp(-0.148*x[0]) + 1) + (0.000131*x[0] + 0.00393)/(7.85381970442166*exp(0.0687*x[0]) - 1));
	dxdt[10] = (-x[10] + 1.0/(0.27354304157175*exp(-0.0925925925925926*x[0]) + 1))/(3.7 + 6.1/(258.6706305155*exp(0.222222222222222*x[0]) + 1));
	dxdt[11] = (-x[11] + 1.0/(44994.057941343*exp(0.178571428571429*x[0]) + 1))/((1.0 - 1.0/(exp((-41.6666666666667)*x[0]) + 1))*(-0.875*x[0] + 12.0) + 12.0/(exp((-41.6666666666667)*x[0]) + 1));
	dxdt[12] = (-x[12] + 1.0/(1.09397774310453*exp(-0.0598802395209581*x[0]) + 1))*(0.25*(7.19e-5*x[0] + 0.002157)/(-0.0117959385197516*exp(-0.148*x[0]) + 1) + 0.25*(0.000131*x[0] + 0.00393)/(7.85381970442166*exp(0.0687*x[0]) - 1));
	dxdt[13] = (0.210526315789474 + 0.00258947368421053/((1.0L/2.0L)*x[7] + (1.0L/2.0L)*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) - 5.4))*(-2.31619578248553*x[0]*x[1]*x[2]*(((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((1 + pow((1.0L/2.0L)*x[7] + (1.0L/2.0L)*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) - 5.4, -9))*(exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - x[13]);
	dxdt[14] = -14.8413159102577*x[14]*exp(0.2*x[0])/(148.413159102577*exp(0.2*x[0]) + 1.0) + 0.015*(-x[14] + 1.0)/(162754.791419004*exp(0.2*x[0]) + 1.0);
	dxdt[15] = -0.273237224472926*x[15]*exp(-0.04*x[0])/(0.0273237224472926*exp(-0.04*x[0]) + 1.0) + 2.01896517994655*(-x[15] + 1.0)*exp(0.04*x[0])/(0.201896517994655*exp(0.04*x[0]) + 1.0);
	dxdt[16] = x[16]*(-3.7933e-7*exp(-0.12987012987013*x[0]) - 3.802/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0]))) + 0.1917*x[17]*exp(-0.0492610837438424*x[0]) + x[21]*(2.0e-5*x[0] + 0.0084);
	dxdt[17] = 3.802*x[16]/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0])) + x[17]*(-3.7933e-7*exp(-0.12987012987013*x[0]) - 0.1917*exp(-0.0492610837438424*x[0]) - 3.802/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0]))) + 0.255858046613164*x[18]*exp(-0.0492610837438424*x[0]) + x[22]*(2.0e-5*x[0] + 0.0084);
	dxdt[18] = 3.802*x[17]/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0])) + x[18]*(-3.7933e-7*exp(-0.12987012987013*x[0]) - 0.255858046613164*exp(-0.0492610837438424*x[0]) - 0.09178*exp(0.0336927223719677*x[0]) - 3.67634709472577e-5*exp(-0.0469163237543198*x[0])/((2.0e-5*x[0] + 0.0084)*(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0])))) + 3.7933e-7*x[19]*exp(-0.12987012987013*x[0]) + x[23]*(2.0e-5*x[0] + 0.0084) + 9.178*x[24]*exp(0.0336927223719677*x[0]);
	dxdt[19] = 0.09178*x[18]*exp(0.0336927223719677*x[0]) + x[19]*(-3.7933e-7*exp(-0.12987012987013*x[0]) - 9.66105263157895e-5*exp(0.0336927223719677*x[0])) + 7.5866e-9*x[20]*exp(-0.12987012987013*x[0]);
	dxdt[20] = 9.66105263157895e-5*x[19]*exp(0.0336927223719677*x[0]) - 7.5866e-9*x[20]*exp(-0.12987012987013*x[0]);
	dxdt[21] = 3.7933e-7*x[16]*exp(-0.12987012987013*x[0]) + x[21]*(-2.0e-5*x[0] - 0.0084 - 3.802/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0]))) + 0.1917*x[22]*exp(-0.0492610837438424*x[0]);
	dxdt[22] = 3.7933e-7*x[17]*exp(-0.12987012987013*x[0]) + 3.802*x[21]/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0])) + x[22]*(-2.0e-5*x[0] - 0.1917*exp(-0.0492610837438424*x[0]) - 0.0084 - 3.802/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0]))) + 0.255858046613164*x[23]*exp(-0.0492610837438424*x[0]);
	dxdt[23] = 3.7933e-7*x[18]*exp(-0.12987012987013*x[0]) + 3.802*x[22]/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0])) + x[23]*(-2.0e-5*x[0] - 0.255858046613164*exp(-0.0492610837438424*x[0]) - 0.0084 - 3.802/(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0]))) + 0.360048370091871*x[24]*exp(-0.0492610837438424*x[0]);
	dxdt[24] = 3.67634709472577e-5*x[18]*exp(-0.0469163237543198*x[0])/((2.0e-5*x[0] + 0.0084)*(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0]))) + 3.802*x[23]/(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0])) + x[24]*(-0.360048370091871*exp(-0.0492610837438424*x[0]) - 9.178*exp(0.0336927223719677*x[0]));
}

rhs_type Model_wtm::get_rhs() {
	return Model_wtm::rhs;
}


// model ttepi ############################################################

Model_ttepi::Model_ttepi() {
	state.push_back( -86.2 ); // Voltage
	state.push_back( 0.0097 ); // Ca_i_total
	state.push_back( 0.27692 ); // Ca_SR_total
	state.push_back( 11.6 ); // Na_i
	state.push_back( 138.3 ); // K_i
	state.push_back( 3.1436e-5 ); // m_gate
	state.push_back( 0.75 ); // h_gate
	state.push_back( 0.75 ); // j_gate
	state.push_back( 0 ); // X_r1_gate
	state.push_back( 1 ); // X_r2_gate
	state.push_back( 0 ); // X_s_gate
	state.push_back( 0 ); // r_gate
	state.push_back( 1 ); // s_gate
	state.push_back( 0 ); // d_gate
	state.push_back( 1 ); // f_gate
	state.push_back( 1 ); // F_Ca
	state.push_back( 1 ); // g_gate


}

unsigned int Model_ttepi::get_N_states() {
	return 17;
}

rhs_type Model_ttepi::get_rhs() {
	return Model_ttepi::rhs;
}

void Model_ttepi::rhs(const state_type &x, state_type &dxdt, const double t) {
	// model: ttepi
	// intermediate results:
	intermediates[0] = constants[5] + constants[6] - x[1];
	intermediates[1] = -1.0L/2.0L*intermediates[0] + (1.0L/2.0L)*sqrt(4*constants[6]*x[1] + pow(intermediates[0], 2));
	intermediates[2] = -1.0L/2.0L*intermediates[3] + (1.0L/2.0L)*sqrt(4*constants[8]*x[2] + pow(intermediates[3], 2));
	intermediates[3] = constants[7] + constants[8] - x[2];
	intermediates[4] = constants[16]*log(constants[0]/x[4]);
	intermediates[5] = constants[16]*log(constants[2]/x[3]);
	intermediates[6] = 0.1/(6.14421235332821e-6*exp(-0.06*intermediates[4] + 0.06*x[0]) + 1.0);

	// rates:
	dxdt[0] = -I_stim - 0.430331482911935*sqrt(constants[0])*constants[18]*x[8]*x[9]*(-intermediates[4] + x[0]) - 1.0*constants[0]*constants[27]*x[3]/((constants[0] + constants[25])*(constants[26] + x[3])*(0.1245*exp(-0.1*constants[38]*x[0]) + 1.0 + 0.0353*exp(-constants[38]*x[0]))) - 4*constants[14]*constants[28]*constants[38]*x[0]*x[13]*x[14]*x[15]*(-0.341*constants[1] + intermediates[1]*exp(2*constants[38]*x[0]))/(exp(2*constants[38]*x[0]) - 1.0) - constants[20]*pow(x[10], 2)*(-constants[16]*log((constants[0] + constants[19]*constants[2])/(constants[19]*x[3] + x[4])) + x[0]) - constants[21]*intermediates[6]*(-intermediates[4] + x[0])/(intermediates[6] + (0.367879441171442*exp(-0.1*intermediates[4] + 0.1*x[0]) + 3.06060402008027*exp(-0.0002*intermediates[4] + 0.0002*x[0]))/(exp(-intermediates[4] - 0.5*x[0]) + 1.0)) - constants[22]*x[11]*x[12]*(-intermediates[4] + x[0]) - constants[23]*pow(x[5], 3)*x[6]*x[7]*(-intermediates[5] + x[0]) - constants[24]*(-intermediates[5] + x[0]) - constants[29]*(-0.5*constants[16]*log(constants[1]/intermediates[1]) + x[0]) - 1.0*constants[30]*(constants[1]*pow(x[3], 3)*exp(constants[34]*constants[38]*x[0]) - 2.5*pow(constants[2], 3)*intermediates[1]*exp(constants[38]*x[0]*(constants[34] - 1)))/((constants[1] + constants[32])*(pow(constants[2], 3) + pow(constants[31], 3))*(constants[33]*exp(constants[38]*x[0]*(constants[34] - 1)) + 1)) - constants[35]*intermediates[1]/(constants[36] + intermediates[1]) - 1.0*constants[37]*(-intermediates[4] + x[0])/(65.4052157419383*exp(-0.167224080267559*x[0]) + 1.0);
	dxdt[1] = -constants[11]/(constants[41]/pow(intermediates[1], 2) + 1.0) + constants[17]*constants[39]*(-4*constants[14]*constants[28]*constants[38]*x[0]*x[13]*x[14]*x[15]*(-0.341*constants[1] + intermediates[1]*exp(2*constants[38]*x[0]))/(exp(2*constants[38]*x[0]) - 1.0) - constants[29]*(-0.5*constants[16]*log(constants[1]/intermediates[1]) + x[0]) + 2.0*constants[30]*(constants[1]*pow(x[3], 3)*exp(constants[34]*constants[38]*x[0]) - 2.5*pow(constants[2], 3)*intermediates[1]*exp(constants[38]*x[0]*(constants[34] - 1)))/((constants[1] + constants[32])*(pow(constants[2], 3) + pow(constants[31], 3))*(constants[33]*exp(constants[38]*x[0]*(constants[34] - 1)) + 1)) - constants[35]*intermediates[1]/(constants[36] + intermediates[1])) - 8.0e-5*intermediates[1] + 8.0e-5*intermediates[2] + x[13]*x[16]*(0.016464*pow(intermediates[2], 2)/(pow(intermediates[2], 2) + 0.0625) + 0.008232);
	dxdt[2] = constants[3]*(constants[11]/(constants[41]/pow(intermediates[1], 2) + 1.0) + 8.0e-5*intermediates[1] - 8.0e-5*intermediates[2] - x[13]*x[16]*(0.016464*pow(intermediates[2], 2)/(pow(intermediates[2], 2) + 0.0625) + 0.008232))/constants[4];
	dxdt[3] = constants[17]*constants[40]*(-3.0*constants[0]*constants[27]*x[3]/((constants[0] + constants[25])*(constants[26] + x[3])*(0.1245*exp(-0.1*constants[38]*x[0]) + 1.0 + 0.0353*exp(-constants[38]*x[0]))) - constants[23]*pow(x[5], 3)*x[6]*x[7]*(-intermediates[5] + x[0]) - constants[24]*(-intermediates[5] + x[0]) - 3.0*constants[30]*(constants[1]*pow(x[3], 3)*exp(constants[34]*constants[38]*x[0]) - 2.5*pow(constants[2], 3)*intermediates[1]*exp(constants[38]*x[0]*(constants[34] - 1)))/((constants[1] + constants[32])*(pow(constants[2], 3) + pow(constants[31], 3))*(constants[33]*exp(constants[38]*x[0]*(constants[34] - 1)) + 1)));
	dxdt[4] = constants[17]*constants[40]*(-I_stim - 0.430331482911935*sqrt(constants[0])*constants[18]*x[8]*x[9]*(-intermediates[4] + x[0]) + 2.0*constants[0]*constants[27]*x[3]/((constants[0] + constants[25])*(constants[26] + x[3])*(0.1245*exp(-0.1*constants[38]*x[0]) + 1.0 + 0.0353*exp(-constants[38]*x[0]))) - constants[20]*pow(x[10], 2)*(-constants[16]*log((constants[0] + constants[19]*constants[2])/(constants[19]*x[3] + x[4])) + x[0]) - constants[21]*intermediates[6]*(-intermediates[4] + x[0])/(intermediates[6] + (0.367879441171442*exp(-0.1*intermediates[4] + 0.1*x[0]) + 3.06060402008027*exp(-0.0002*intermediates[4] + 0.0002*x[0]))/(exp(-intermediates[4] - 0.5*x[0]) + 1.0)) - constants[22]*x[11]*x[12]*(-intermediates[4] + x[0]) - 1.0*constants[37]*(-intermediates[4] + x[0])/(65.4052157419383*exp(-0.167224080267559*x[0]) + 1.0));
	dxdt[5] = 1.0*(-x[5] + 1.0/pow(0.00184221158116513*exp(-0.110741971207087*x[0]) + 1.0, 2))*(6.14421235332821e-6*exp(-0.2*x[0]) + 1.0)/(0.1/(1096.63315842846*exp(0.2*x[0]) + 1.0) + 0.1/(0.778800783071405*exp(0.005*x[0]) + 1.0));
	dxdt[6] = (-x[6] + 1.0/pow(15212.5932856544*exp(0.134589502018843*x[0]) + 1.0, 2))/((1 - 1.0/(exp((-41.6666666666667)*(x[0] + 40)) + 1))*(0.0646209624466736*exp(-0.0900900900900901*x[0]) + 0.168831168831169) + 1.0/((exp((-41.6666666666667)*(x[0] + 40)) + 1)*(4.43126792958051e-7*exp(-0.147058823529412*x[0]) + 2.7*exp(0.079*x[0]) + 310000.0*exp(0.3485*x[0]))));
	dxdt[7] = (-x[7] + 1.0/pow(15212.5932856544*exp(0.134589502018843*x[0]) + 1.0, 2))/(1.66666666666667*(1 - 1.0/(exp((-41.6666666666667)*(x[0] + 40)) + 1))*(0.0407622039783662*exp(-0.1*x[0]) + 1.0)*exp(-0.057*x[0]) + 1.0/(((x[0] + 37.78)*(-6.948e-6*exp(-0.04391*x[0]) - 25428.0*exp(0.2444*x[0]))/(50262745825.954*exp(0.311*x[0]) + 1.0) + 0.02424*exp(-0.01052*x[0])/(0.00396086833990426*exp(-0.1378*x[0]) + 1.0))*(exp((-41.6666666666667)*(x[0] + 40)) + 1)));
	dxdt[8] = 0.00037037037037037*(-x[8] + 1.0/(0.0243728440732796*exp(-0.142857142857143*x[0]) + 1.0))*(0.0111089965382423*exp(-0.1*x[0]) + 1.0)*(13.5813245225782*exp(0.0869565217391304*x[0]) + 1.0);
	dxdt[9] = 0.297619047619048*(-x[9] + 1.0/(39.1212839981532*exp(0.0416666666666667*x[0]) + 1.0))*(0.0497870683678639*exp(-0.05*x[0]) + 1.0)*(0.0497870683678639*exp(0.05*x[0]) + 1.0);
	dxdt[10] = 0.000909090909090909*sqrt(1.0 + 0.188875602837562*exp(-1.0L/6.0L*x[0]))*(-x[10] + 1.0/(0.69967253737513*exp(-0.0714285714285714*x[0]) + 1.0))*(0.0497870683678639*exp(0.05*x[0]) + 1.0);
	dxdt[11] = (-x[11] + 1.0/(28.0316248945261*exp(-0.166666666666667*x[0]) + 1.0))/(9.5*exp(0.000555555555555556*(-x[0] - 40.0)*(x[0] + 40.0)) + 0.8);
	dxdt[12] = (-x[12] + 1.0/(54.5981500331442*exp(0.2*x[0]) + 1.0))/(85.0*exp(0.003125*(-x[0] - 45.0)*(x[0] + 45.0)) + 3.0 + 5.0/(0.0183156388887342*exp(0.2*x[0]) + 1.0));
	dxdt[13] = (-x[13] + 1.0/(0.513417119032592*exp(-0.133333333333333*x[0]) + 1.0))/(1.4*(0.25 + 1.4/(exp(-1.0L/13.0L*x[0] - 35.0L/13.0L) + 1.0))/(exp((1.0L/5.0L)*x[0] + 1) + 1.0) + 1.0/(exp(-1.0L/20.0L*x[0] + 5.0L/2.0L) + 1.0));
	dxdt[14] = (-x[14] + 1.0/(exp((1.0L/7.0L)*x[0] + 20.0L/7.0L) + 1.0))/(1125*exp((1.0L/300.0L)*(-x[0] - 27)*(x[0] + 27)) + 80 + 165/(exp(-1.0L/10.0L*x[0] + 5.0L/2.0L) + 1.0));
	dxdt[15] = 1.0*(-x[15] + 0.157534246575342 + 0.0684931506849315/(0.00673794699908547*exp(10000.0*intermediates[1]) + 1.0) + 0.136986301369863/(0.391605626676799*exp(1250.0*intermediates[1]) + 1.0) + 0.684931506849315/(8.03402376701711e+27*pow(intermediates[1], 8) + 1.0))/(constants[9]*(exp(41.6666666666667*(x[0] + 60)) + 1)*(exp(5000*(-x[14] + 1.0/(exp((1.0L/7.0L)*x[0] + 20.0L/7.0L) + 1.0))) + 1));
	dxdt[16] = 1.0*(-x[16] + 1.0*(1 - 1.0/(exp((-41.6666666666667)*(intermediates[1] - 0.00035)) + 1))/(1.97201988740492e+55*pow(intermediates[1], 16) + 1.0) + 1.0/((5.43991024148102e+20*pow(intermediates[1], 6) + 1.0)*(exp((-41.6666666666667)*(intermediates[1] - 0.00035)) + 1)))/(constants[10]*(exp(41.6666666666667*(x[0] + 60)) + 1)*(exp(5000*(-x[16] + 1.0*(1 - 1.0/(exp((-41.6666666666667)*(intermediates[1] - 0.00035)) + 1))/(1.97201988740492e+55*pow(intermediates[1], 16) + 1.0) + 1.0/((5.43991024148102e+20*pow(intermediates[1], 6) + 1.0)*(exp((-41.6666666666667)*(intermediates[1] - 0.00035)) + 1)))) + 1));
}

std::array<double, 7> Model_ttepi::intermediates;

std::array<double, 42> Model_ttepi::constants = {{
	5.4, // Ko [0]
	2.0, // Cao [1]
	140.0, // Nao [2]
	0.016404, // Vc [3]
	0.001094, // Vsr [4]
	0.15, // Bufc [5]
	0.001, // Kbufc [6]
	10.0, // Bufsr [7]
	0.3, // Kbufsr [8]
	2.0, // taufca [9]
	2.0, // taug [10]
	0.000425, // Vmaxup [11]
	0.00025, // Kup [12]
	8314.472, // R [13]
	96485.3415, // F [14]
	310.0, // T [15]
	26.7137606597, // RTONF [16]
	0.185, // CAPACITANCE [17]
	0.096, // Gkr [18]
	0.03, // pKNa [19]
	0.245, // Gks [20]
	5.405, // GK1 [21]
	0.294, // Gto [22]
	14.838, // GNa [23]
	0.00029, // GbNa [24]
	1.0, // KmK [25]
	40.0, // KmNa [26]
	1.362, // knak [27]
	0.000175, // GCaL [28]
	0.000592, // GbCa [29]
	1000, // knaca [30]
	87.5, // KmNai [31]
	1.38, // KmCa [32]
	0.1, // ksat [33]
	0.35, // n [34]
	0.825, // GpCa [35]
	0.0005, // KpCa [36]
	0.0146, // GpK [37]
	0.0374338908227, // FONRT [38]
	0.000315906749849, // inverseVcF2 [39]
	0.000631813499697, // inverseVcF [40]
	6.25e-08 // Kupsquare [41]
}};

/*  odeint doesn't work as as i thought
void Buffered_save_state::operator()( state_type &x , const double t ) {
	m_entries++;
	std::clog << "saviour called for "<<m_entries<<". entry, t = " << t <<" (m_mem_size="<<m_mem_size<<"\n";
	*(m_write_marker++) = t;
	for (int i=0; i<m_dim_state; ++i) {
		*(m_write_marker+i) = x[i];
	}
	//std::clog << "marker: " << m_write_marker-m_memory <<" -> "; 
	if (m_entries == m_mem_size) {
		save_mem();
	} else {
		m_write_marker += m_dim_state; 
	}
	std::clog << "saviour call ended\n";
	//std::clog << m_entries << " entries\n";
}

void Buffered_save_state::save_mem() {
	if (m_entries==0)
		return;
	const unsigned int save_shape[] = {m_entries, m_dim_state+1};
	//print_mem();
	std::clog << "svae shape: " << save_shape[0] << ", " << save_shape[1]<<"\n";
	cnpy::npy_save(m_filename, m_memory, save_shape, 2, "a");
	//std::clog << "saved " << m_entries << " states.\n";
	m_write_marker = m_memory;
	m_entries = 0;
}

void Buffered_save_state::print_mem() {
	std::clog << m_entries << " states:\n";
	for (int i=0; i<m_entries; i++) {
		for (int k=0; k<(m_dim_state+1); k++)
			std::clog << m_memory[i*(m_dim_state+1)+k] << "\t";
		std::clog << "\n";
	}
}
*/

void MemoryNpy::push(double x) {
	m_data[m_elements++] = x;
	if (m_elements==m_capacity)
		push_to_file();
}

void MemoryNpy::push_to_file() {
	const unsigned int shape[] = {m_elements, m_group_size};
	cnpy::npy_save(m_filename, m_data, shape, 2, "a");
	m_elements = 0;	
}

